@rem = '--*-Perl-*--
@echo off
if "%OS%" == "Windows_NT" goto WinNT
perl -x -S "%0" %1 %2 %3 %4 %5 %6 %7 %8 %9
goto endofperl
:WinNT
perl -x -S "%0" %*
if NOT "%COMSPEC%" == "%SystemRoot%\system32\cmd.exe" goto endofperl
if %errorlevel% == 9009 echo You do not have Perl in your PATH.
if errorlevel 1 goto script_failed_so_exit_with_non_zero_val 2>nul
goto endofperl
@rem ';
#!/usr/bin/perl
#line 15

# ToDo 	set up $SBBS_CTRL_PATH properly.
# $SBBS_CTRL_PATH = $ENV{'SBBSCTRL'};
if (defined $ARGV[0])  {
        $SBBS_CTRL_PATH = $ARGV[0];
        $SBBS_CTRL_PATH =~ s/\\/\//g;
        $SBBS_CTRL_PATH =~ s/\/$//g;
}
else  {
        $SBBS_CTRL_PATH = $ENV{'SBBSCTRL'};
        $SBBS_CTRL_PATH =~ s/\\/\//g;
        $SBBS_CTRL_PATH =~ s/\/$//g;
}

if (! -e "$SBBS_CTRL_PATH/main.cnf")  {
        if ($^O =~ /Win32/)  {
                $SBBS_CTRL_PATH = 'C:/SBBS/CTRL';
        }
        else  {
                $SBBS_CTRL_PATH = '/sbbs/ctrl';
        }
}

if (! -e "$SBBS_CTRL_PATH/main.cnf")  {
        print "\n                  Synchronet .TXT to .NFT converter v0.2\n";
        print "                  -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=\n\n";

        print "This perl script will convert all your plain-text config files to equivent .cnf\n";  
        print "files for use with Synchronet.\n\n";

        print "To use, run it with your ctrl path as the only option as follows:\n";
        print "txt2cnf /sbbs/ctrl\n\n";

}

&write_main;

foreach $node_dir (@{$main{'node_dir'}})  {
        $node_dir =~ s/\\/\//g;
        $node_dir =~ s/\/$//g;
        if ($^O =~ /Win32/)  {
                if ($node_dir !~ /:/)  {
                        $node_dir = "$SBBS_CTRL_PATH/$node_dir/";
                        $node_dir =~ s/\/[^\/]*\/..\//\//g;
                        $node_dir =~ s/\/.\//\//g;
                        $node_dir =~ s/\/$//g;
                }
        }
        else  {
                $node_dir = '$SBBS_CTRL_PATH/$node_dir/';
                $node_dir =~ s/\/[^\/]*\/..\//\//g;
                $node_dir =~ s/\/.\//\//g;
                $node_dir =~ s/\/$//g;
        }
        &write_node($node_dir);
}

&write_msgs;
&write_file;
&write_xtrn;
&write_chat;

sub read_txt_file  {
        my ($file) = @_;
        my %file_hash = ();

        while (<$file>)  {
                chomp;
                /([^=]*) = (.*)/;
                ($key, $value) = ($1, $2);
                @damn_references = split(/\./,$key);
                if ($#damn_references == 0)  {
                        # Only one key.
                        if ($key =~ /^(.*)\[([0-9]*)\]$/)  {
                                ($key, $position) = ($1,$2);
                                $file_hash{$key}[$position] = $value;
                        }
                        else  {
                                $file_hash{$key} = $value;
                        }
                }
                elsif ($#damn_references == 1)  {
                        $damn_references[0] =~ /^(.*)\[([0-9]*)\]$/;
                        ($key1, $position1) = ($1,$2);
                        if ($damn_references[1] =~ /^(.*)\[([0-9]*)\]$/)  {
                                ($key2, $position2) = ($1,$2);
                                $file_hash{$key1}[$position1]{$key2}[$position2] = $value;
                        }
                        else  {
                                $file_hash{$key1}[$position1]{$damn_references[1]} = $value;
                        }
                        
                }
                elsif ($#damn_references == 2)  {
                        $damn_references[0] =~ /^(.*)\[([0-9]*)\]$/;
                        ($key1, $position1) = ($1,$2);
                        $damn_references[1] =~ /^(.*)\[([0-9]*)\]$/;
                        ($key2, $position2) = ($1,$2);
                        if ($damn_references[3] =~ /^(.*)\[([0-9]*)\]$/)  {
                                ($key3, $position3) = ($1,$2);
                                $file_hash{$key1}[$position1]{$key2}[$position2]{$key3}[$position3] = $value;
                        }
                        else  {
                                $file_hash{$key1}[$position1]{$key2}[$position2]{$damn_references[2]} = $value;
                        }
                }
        }

        return %file_hash;
}

sub write_main  {

        open MAIN,"$SBBS_CTRL_PATH/main.txt";
        %main = &read_txt_file(\*MAIN);
        close MAIN;

        open MAIN,">$SBBS_CTRL_PATH/main.cnf";
        binmode(MAIN);

        $buffer = pack('Z41Z9Z41Z13Z41Z41Z41v',($main{'sys_name'},
                $main{'sys_id'},$main{'sys_location'},$main{'sys_phonefmt'},
                $main{'sys_op'},$main{'sys_guru'},$main{'sys_pass'},
                $main{'sys_nodes'}));
        print MAIN $buffer;

        foreach (1..$main{'sys_nodes'})  {
                $buffer = pack('Z64',(${$main{'node_dir'}}[$_-1]));
                print MAIN $buffer;
	}

        $buffer=pack('Z64Z64Z64Z64Z64vVvvVvvCvCZ41vVVZ41Z21Z9Z9',
                ($main{'data_dir'},$main{'exec_dir'},$main{'sys_logon'},
                $main{'sys_logoff'},$main{'sys_daily'},$main{'sys_timezone'},
                $main{'sys_misc'},$main{'sys_lastnode'},$main{'sys_autonode'},
                $main{'uq'},$main{'sys_pwdays'},$main{'sys_deldays'},
                $main{'sys_exp_warn'},$main{'sys_autodel'},
                $main{'sys_def_stat'},$main{'sys_chat_ar'},
                $main{'cdt_min_value'},$main{'max_minutes'},$main{'cdt_per_dollar'},
                $main{'new_pass'},$main{'new_magic'},$main{'new_sif'},
                $main{'new_sof'}));
        print MAIN $buffer;

        $buffer=pack('CV8Z9vvVZ16',
                ($main{'new_level'},$main{'new_flags1'},$main{'new_flags2'},
                $main{'new_flags3'},$main{'new_flags4'},$main{'new_exempt'},
                $main{'new_rest'},$main{'new_cdt'},$main{'new_min'},
                $main{'new_xedit'},$main{'new_expire'},$main{'new_shell'},
                $main{'new_misc'},"\x00" x 16));
        print MAIN $buffer;

        $buffer=pack('CV6',
                ($main{'expired_level'},$main{'expired_flags1'},
                $main{'expired_flags2'},$main{'expired_flags3'},
                $main{'expired_flags4'},$main{'expired_exempt'},
                $main{'expired_rest'}));
        print MAIN $buffer;

        $buffer=pack('Z9Z9Z9Z485Z512',
                ($main{'logon_mod'},$main{'logoff_mod'},
                $main{'newuser_mod'}, "\x00" x 485, "\xFF" x 512));
        print MAIN $buffer;

	foreach (1..10)  {
                my $this_main = ${$main{'validation_set'}}[$_-1];
                my %this_main = %{$this_main};
                $buffer=pack('CvVVVVVVVZ16',
                        ($this_main{'val_level'},
                        $this_main{'val_expire'},
                        $this_main{'val_flags1'},
                        $this_main{'val_flags2'},
                        $this_main{'val_flags3'},
                        $this_main{'val_flags4'},
                        $this_main{'val_cdt'},
                        $this_main{'val_exempt'},
                        $this_main{'val_rest'},
                        "\x00" x 16));
                print MAIN $buffer;
	}

	foreach (1..100)  {
                my $this_main = ${$main{'security_level'}}[$_-1];
                my %this_main = %{$this_main};
                $buffer=pack('vvvVvvvZ16',
                        ($this_main{'level_timeperday'},
                        $this_main{'level_timepercall'},
                        $this_main{'level_callsperday'},
                        $this_main{'level_freecdtperday'},
                        $this_main{'level_linespermsg'},
                        $this_main{'level_postsperday'},
                        $this_main{'level_emailperday'},
                        "\x00" x 16));
                print MAIN $buffer;
	}

        $buffer=pack('v',($main{'total_shells'}));
        print MAIN $buffer;

        foreach (1..$main{'total_shells'})  {
                my $this_main = ${$main{'command_shell'}}[$_-1];
                my %this_main = %{$this_main};
                $buffer=pack('Z41Z9Z41VZ16',
                        ($this_main{'name'},
                        $this_main{'code'},
                        $this_main{'ar'},
                        $this_main{'misc'}));
                print MAIN $buffer;
	}

	close MAIN;
}

sub write_node  {
        my ($NODE_PATH) = @_;

        open NODE,"$NODE_PATH/node.txt";
        %node = &read_txt_file(\*NODE);
        close NODE;

        open NODE,">$NODE_PATH/node.cnf";
        binmode(NODE);

        $buffer = pack('vZ41Z13Z64VvCZ64vvZ41CZ64Z64Z64CCZ64Z64Z64Z64Z64Z'.
                '64Z64Z64Z64Z64Z64Z64Z64Z64Z64Z64Z64Z64Z64Z64Z64Z64Z64Z64'.
                'Z64Z512Z512',
                ($node{'node_num'},$node{'node_name'},$node{'node_phone'},
                $node{'node_logon'},$node{'node_misc'},$node{'node_ivt'},
                $node{'node_swap'},$node{'node_swapdir'},$node{'node_valuser'},
                $node{'node_minbps'},$node{'node_ar'},$node{'node_dollars_per_call'},
                $node{'node_editor'},$node{'node_viewer'},$node{'node_daily'},
                $node{'node_scrnlen'},$node{'node_scrnblank'},$node{'ctrl_dir'},
                $node{'text_dir'},$node{'temp_dir'},$node{'wfc_cmd1'},
                $node{'wfc_cmd2'},$node{'wfc_cmd3'},$node{'wfc_cmd4'},
                $node{'wfc_cmd5'},$node{'wfc_cmd6'},$node{'wfc_cmd7'},
                $node{'wfc_cmd8'},$node{'wfc_cmd9'},$node{'wfc_cmd10'},
                $node{'wfc_scmd1'},$node{'wfc_scmd2'},$node{'wfc_scmd3'},
                $node{'wfc_scmd4'},$node{'wfc_scmd5'},$node{'wfc_scmd6'},
                $node{'wfc_scmd7'},$node{'wfc_scmd8'},$node{'wfc_scmd9'},
                $node{'wfc_scmd10'},$node{'wfc_scmd11'},
                $node{'wfc_scmd12'}, "\x00" x 512, "\xFF" x 512));
        print NODE $buffer;

        $buffer=pack('CvvV',
                ($node{'com_port'},$node{'com_irq'},$node{'com_base'},
                $node{'com_rate'}));
        print NODE $buffer;

        $buffer=pack('VZ64Z64Z64Z64Z64Z64vvCv',
                ($node{'mdm_misc'},$node{'mdm_init'},$node{'mdm_spec'},
                $node{'mdm_term'},$node{'mdm_dial'},$node{'mdm_offh'},
                $node{'mdm_answ'},$node{'mdm_reinit'},$node{'mdm_ansdelay'},
                $node{'mdm_rings'},$node{'mdm_results'}));
        print NODE $buffer;

        foreach (1..$node{'mdm_results'})  {
                my $this_node = ${$node{'mdm_result'}}[$_-1];
                my %this_node = %{$this_node};
                $buffer=pack('vvvZ9',
                        ($this_node{'code'},$this_node{'rate'},
                        $this_node{'cps'},
                        $this_node{'str'}));
                print NODE $buffer;
        }

        close NODE;
}

sub write_msgs  {

        my $unused = "\x00" x 512;
        my $unused_ff = "\xFF" x 512;

        open MSGS,"$SBBS_CTRL_PATH/msgs.txt";
        %msgs = &read_txt_file(\*MSGS);
        close MSGS;

        open MSGS,">$SBBS_CTRL_PATH/msgs.cnf";
        binmode(MSGS);

        $buffer = pack('VVvZ512Z512v',
                ($msgs{'max_qwkmsgs'},$msgs{'mail_maxcrcs'},$msgs{'mail_maxage'},
                $unused,$unused_ff,
                $msgs{'total_grps'}));
        print MSGS $buffer;

        foreach (1..$msgs{'total_grps'})  {
                my $this_msgs = ${$msgs{'grp'}}[$_-1];
                my %this_msgs = %{$this_msgs};
                $buffer=pack('Z41Z16Z41Z96',
                        ($this_msgs{'lname'},$this_msgs{'sname'},
                        $this_msgs{'ar'},$unused));
                print MSGS $buffer;
        }

        $buffer = pack('v',
                ($msgs{'total_subs'}));
        print MSGS $buffer;

        foreach (1..$msgs{'total_subs'})  {
                my $this_msgs = ${$msgs{'sub'}}[$_-1];
                my %this_msgs = %{$this_msgs};
                $this_msgs{'faddr'} = &pack_faddr($this_msgs{'faddr'});
                $buffer=pack('vZ41Z26Z11Z9Z64Z41Z41Z41Z41VZ81Z51Z64Z64Z8VVvvZ41vZ53',
                        ($this_msgs{'grp'},$this_msgs{'lname'},
                        $this_msgs{'sname'},$this_msgs{'qwkname'},
                        $this_msgs{'code'},$this_msgs{'data_dir'},
                        $this_msgs{'ar'},$this_msgs{'read_ar'},
                        $this_msgs{'post_ar'},$this_msgs{'op_ar'},
                        $this_msgs{'misc'},$this_msgs{'tagline'},
                        $this_msgs{'originline'},$this_msgs{'echomail_sem'},
                        $this_msgs{'echopath'},$this_msgs{'faddr'},
                        $this_msgs{'maxmsgs'},$this_msgs{'maxcrcs'},
                        $this_msgs{'maxage'},$this_msgs{'ptridx'},
                        $this_msgs{'mod_ar'},
                        $this_msgs{'qwkconf'},$unused));
                print MSGS $buffer;
        }

        $buffer = pack('v',
                ($msgs{'total_faddrs'}));
        print MSGS $buffer;

        foreach (1..$msgs{'total_faddrs'})  {
                my $this_msgs = ${$msgs{'faddr'}}[$_-1];
                print MSGS &pack_faddr($this_msgs);
        }

        $msgs{'dflt_faddr'} = &pack_faddr($msgs{'dflt_faddr'});
        $buffer = pack('Z51Z64Z64Z64Z64Z64vVZ8Z56',
                ($msgs{'origline'},$msgs{'netmail_sem'},$msgs{'echomail_sem'},
                $msgs{'netmail_dir'},$msgs{'echomail_dir'},$msgs{'fidofile_dir'},
                $msgs{'netmail_misc'},$msgs{'netmail_cost'},
                $msgs{'dflt_faddr'}));
        print MSGS $buffer;

        $buffer = pack('Z128',
                ($msgs{'qnet_tagline'}));
        print MSGS $buffer;

        $buffer = pack('v',
                ($msgs{'total_qhubs'}));
        print MSGS $buffer;

        foreach (1..$msgs{'total_qhubs'})  {
                my $this_msgs = ${$msgs{'qhub'}}[$_-1];
                my %this_msgs = %{$this_msgs};
                $buffer=pack('Z9vvCvZ64Z64Z64v',
                        ($this_msgs{'id'},$this_msgs{'time'},
                        $this_msgs{'freq'},$this_msgs{'days'},
                        $this_msgs{'node'},$this_msgs{'call'},
                        $this_msgs{'pack'},$this_msgs{'unpack'},
                        $this_msgs{'subs'}));
                print MSGS $buffer;
                foreach (1..$this_msgs{'subs'})  {
                        print "Bork!\n";
                        my $this_msgs2 = ${$msgs{'qsub'}}[$_-1];
                        my %this_msgs2 = %{$this_msgs2};
                        $buffer=pack('vvC',
                                ($this_msgs2{'conf'},
                                $this_msgs2{'sub'},
                                $this_msgs2{'mode'}));
                        print MSGS $buffer;
                }
                print MSGS pack('Z64',$unused);
        }
        print MSGS pack('Z75',$unused);

        $buffer=pack('V',
                ($msgs{'sys_psnum'}));
        print MSGS $buffer;

        $buffer=pack('v',
                ($msgs{'total_phubs'}));
        print MSGS $buffer;

        foreach (1..$msgs{'total_phubs'})  {
                my $this_msgs = ${$msgs{'phub'}}[$_-1];
                my %this_msgs = %{$this_msgs};
                $buffer=pack('Z11vvCvZ41Z64',
                        ($this_msgs{'name'},$this_msgs{'time'},
                        $this_msgs{'freq'},$this_msgs{'days'},
                        $this_msgs{'node'},
                        $this_msgs{'call'},$unused));
                print MSGS $buffer;
        }

        $buffer=pack('Z64Z13Z64',
                ($unused,$msgs{'sys_psname'},$unused));
        print MSGS $buffer;

        $buffer=pack('Z128',
                ($msgs{'sys_inetaddr'}));
        print MSGS $buffer;

        close MSGS;
}

sub pack_faddr  {
        my ($faddr) = @_;
        my @faddr = split(/[\.\/\:]/,$faddr);
        return pack('vvvv',@faddr);
}

sub write_file  {
        my $unused = "\x00" x 512;
        my $unused_ff = "\xFF" x 512;

        open FILE,"$SBBS_CTRL_PATH/file.txt";
        %file = &read_txt_file(\*FILE);
        close FILE;

        open FILE,">$SBBS_CTRL_PATH/file.cnf";
        binmode(FILE);

        $buffer = pack('vvvvVvvVZ64vvZ64',
                ($file{'min_dspace'},$file{'max_batup'},$file{'max_batdn'},
                $file{'max_userxfer'},$unused,$file{'default_cdt_up_pct'},
                $file{'default_cdt_dn_pct'},$unused,$unused,
                $file{'leech_pct'},$file{'leech_sec'},$unused));
        print FILE $buffer;

        $buffer = pack('v',
                ($file{'total_fextrs'}));
        print FILE $buffer;
        foreach (1..$file{'total_fextrs'})  {
                my $this_file = ${$file{'fextr'}}[$_-1];
                my %this_file = %{$this_file};
                $buffer=pack('Z4Z64Z41Z16',
                        ($this_file{'ext'},$this_file{'cmd'},
                        $this_file{'ar'},$unused));
                print FILE $buffer;
        }

        $buffer = pack('v',
                ($file{'total_fcomps'}));
        print FILE $buffer;
        foreach (1..$file{'total_fcomps'})  {
                my $this_file = ${$file{'fcomp'}}[$_-1];
                my %this_file = %{$this_file};
                $buffer=pack('Z4Z64Z41Z16',
                        ($this_file{'ext'},$this_file{'cmd'},
                        $this_file{'ar'},$unused));
                print FILE $buffer;
        }

        $buffer = pack('v',
                ($file{'total_fviews'}));
        print FILE $buffer;
        foreach (1..$file{'total_fviews'})  {
                my $this_file = ${$file{'fview'}}[$_-1];
                my %this_file = %{$this_file};
                $buffer=pack('Z4Z64Z41Z16',
                        ($this_file{'ext'},$this_file{'cmd'},
                        $this_file{'ar'},$unused));
                print FILE $buffer;
        }

        $buffer = pack('v',
                ($file{'total_ftests'}));
        print FILE $buffer;
        foreach (1..$file{'total_ftests'})  {
                my $this_file = ${$file{'ftest'}}[$_-1];
                my %this_file = %{$this_file};
                $buffer=pack('Z4Z64Z41Z41Z16',
                        ($this_file{'ext'},$this_file{'cmd'},$this_file{'workstr'},
                        $this_file{'ar'},$unused));
                print FILE $buffer;
        }

        $buffer = pack('v',
                ($file{'total_dlevents'}));
        print FILE $buffer;
        foreach (1..$file{'total_dlevents'})  {
                my $this_file = ${$file{'dlevelt'}}[$_-1];
                my %this_file = %{$this_file};
                $buffer=pack('Z4Z64Z41Z41Z16',
                        ($this_file{'ext'},$this_file{'cmd'},
                        $this_file{'workstr'},
                        $this_file{'ar'},$unused));
                print FILE $buffer;
        }

        $buffer = pack('v',
                ($file{'total_prots'}));
        print FILE $buffer;
        foreach (1..$file{'total_prots'})  {
                my $this_file = ${$file{'prot'}}[$_-1];
                my %this_file = %{$this_file};
                $buffer=pack('AZ26Z64Z64Z64Z64Z64Z64VZ41Z16',
                        ($this_file{'mnemonic'},$this_file{'name'},
                        $this_file{'ulcmd'},$this_file{'dlcmd'},
                        $this_file{'batulcmd'},$this_file{'batdlcmd'},
                        $this_file{'unused'},$this_file{'bicmd'},
                        $this_file{'misc'},
                        $this_file{'ar'},$unused));
                print FILE $buffer;
        }

        $buffer = pack('v',
                ($file{'altpaths'}));
        print FILE $buffer;
        foreach (1..$file{'altpaths'})  {
                my $this_file = ${$file{'altpath'}}[$_-1];
                $buffer=pack('Z64Z16',($this_file,$unused));
                print FILE $buffer;
        }
        
        $buffer = pack('v',
                ($file{'total_libs'}));
        print FILE $buffer;
        foreach (1..$file{'total_libs'})  {
                my $this_file = ${$file{'lib'}}[$_-1];
                my %this_file = %{$this_file};
                $buffer=pack('Z41Z16Z41Z96',
                        ($this_file{'lname'},$this_file{'sname'},
                        $this_file{'ar'},$unused));
                print FILE $buffer;
        }

        $buffer = pack('v',
                ($file{'total_dirs'}));
        print FILE $buffer;
        foreach (1..$file{'total_dirs'})  {
                my $this_file = ${$file{'dir'}}[$_-1];
                my %this_file = %{$this_file};
                $buffer=pack('vZ41Z26Z9Z64Z41Z41Z41Z41Z64Z64vZ41VCCZ41vvvZ49',
                        ($this_file{'lib'},$this_file{'lname'},
                        $this_file{'sname'},$this_file{'code'},
                        $this_file{'data_dir'},$this_file{'ar'},
                        $this_file{'ul_ar'},$this_file{'dl_ar'},
                        $this_file{'op_ar'},$this_file{'path'},
                        $this_file{'upload_sem'},$this_file{'maxfiles'},
                        $this_file{'exts'},$this_file{'misc'},
                        $this_file{'seqdev'},$this_file{'sort'},
                        $this_file{'ex_ar'},$this_file{'maxage'},
                        $this_file{'up_pct'},
                        $this_file{'dn_pct'},$unused));
                print FILE $buffer;
        }

        $buffer = pack('v',
                ($file{'total_txtsecs'}));
        print FILE $buffer;
        foreach (1..$file{'total_txtsecs'})  {
                my $this_file = ${$file{'txtsec'}}[$_-1];
                my %this_file = %{$this_file};
                $buffer=pack('Z41Z9Z41Z16',
                        ($this_file{'name'},$this_file{'code'},
                        $this_file{'ar'},$unused));
                print FILE $buffer;
        }

        close FILE;
}

sub write_xtrn  {
        my $unused = "\x00" x 512;
        my $unused_ff = "\xFF" x 512;

        open XTRN,"$SBBS_CTRL_PATH/xtrn.txt";
        %xtrn = &read_txt_file(\*XTRN);
        close XTRN;

        open XTRN,">$SBBS_CTRL_PATH/xtrn.cnf";
        binmode(XTRN);

        $buffer = pack('v',
                ($xtrn{'total_swaps'}));
        print XTRN $buffer;
        foreach (1..$xtrn{'total_swaps'})  {
                my $this_xtrn = ${$xtrn{'swap'}}[$_-1];
                $buffer=pack('Z64',($this_xtrn));
                print XTRN $buffer;
        }

        $buffer = pack('v',
                ($xtrn{'total_xedits'}));
        print XTRN $buffer;
        foreach (1..$xtrn{'total_xedits'})  {
                my $this_xtrn = ${$xtrn{'xedit'}}[$_-1];
                my %this_xtrn = %{$this_xtrn};
                $buffer=pack('Z41Z9Z64Z64VZ41Z16',
                        ($this_xtrn{'name'},$this_xtrn{'code'},
                        $this_xtrn{'lcmd'},$this_xtrn{'rcmd'},
                        $this_xtrn{'misc'},
                        $this_xtrn{'ar'},$unused));
                print XTRN $buffer;
        }

        $buffer = pack('v',
                ($xtrn{'total_xtrnsecs'}));
        print XTRN $buffer;
        foreach (1..$xtrn{'total_xtrnsecs'})  {
                my $this_xtrn = ${$xtrn{'xtrnsec'}}[$_-1];
                my %this_xtrn = %{$this_xtrn};
                $buffer=pack('Z41Z9Z41Z16',
                        ($this_xtrn{'name'},$this_xtrn{'code'},
                        $this_xtrn{'ar'},$unused));
                print XTRN $buffer;
        }

        $buffer = pack('v',
                ($xtrn{'total_xtrns'}));
        print XTRN $buffer;
        foreach (1..$xtrn{'total_xtrns'})  {
                my $this_xtrn = ${$xtrn{'xtrn'}}[$_-1];
                my %this_xtrn = %{$this_xtrn};
                $buffer=pack('vZ41Z9Z41Z41CVCVZ64Z64Z64Z16',
                        ($this_xtrn{'sec'},$this_xtrn{'name'},
                        $this_xtrn{'code'},$this_xtrn{'ar'},
                        $this_xtrn{'run_ar'},$this_xtrn{'type'},
                        $this_xtrn{'misc'},$this_xtrn{'event'},
                        $this_xtrn{'cost'},$this_xtrn{'cmd'},
                        $this_xtrn{'clean'},
                        $this_xtrn{'path'},$unused));
                print XTRN $buffer;
        }

        $buffer = pack('v',
                ($xtrn{'total_events'}));
        print XTRN $buffer;
        foreach (1..$xtrn{'total_events'})  {
                my $this_xtrn = ${$xtrn{'event'}}[$_-1];
                my %this_xtrn = %{$this_xtrn};
                $buffer=pack('Z9Z64CvvVZ64Z16',
                        ($this_xtrn{'code'},$this_xtrn{'cmd'},
                        $this_xtrn{'days'},$this_xtrn{'time'},
                        $this_xtrn{'node'},$this_xtrn{'misc'},
                        $this_xtrn{'dir'},$unused));
                push @{$xtrn{'event'}},\%this_xtrn;
                print XTRN $buffer;
        }

        $buffer = pack('v',
                ($xtrn{'total_natvpgms'}));
	print XTRN $buffer;
        foreach (1..$xtrn{'total_natvpgms'})  {
                $buffer=pack('Z13',${$xtrn{'natvpgms->name'}}[$_-1]);
		print XTRN $buffer;
        }
        foreach (1..$xtrn{'total_natvpgms'})  {
                $buffer=pack('V',${$xtrn{'natvpgms->misc'}}[$_-1]);
		print XTRN $buffer;
        }

        close XTRN;
}

sub write_chat  {
        my $unused = "\x00" x 512;
        my $unused_ff = "\xFF" x 512;

        open CHAT,"$SBBS_CTRL_PATH/chat.txt";
        %chat = &read_txt_file(\*CHAT);
        close CHAT;

        open CHAT,">$SBBS_CTRL_PATH/chat.cnf";
        binmode(CHAT);

        $buffer = pack('v',
                ($chat{'total_gurus'}));
        print CHAT $buffer;
        foreach (1..$chat{'total_gurus'})  {
                my $this_chat = ${$chat{'guru'}}[$_-1];
                my %this_chat = %{$this_chat};
                $buffer=pack('Z26Z9Z41Z16',
                        ($this_chat{'name'},$this_chat{'code'},
                        $this_chat{'ar'},$unused));
                print CHAT $buffer;
        }

        $buffer = pack('v',
                ($chat{'total_actsets'}));
        print CHAT $buffer;
        foreach (1..$chat{'total_actsets'})  {
                my $this_chat = ${$chat{'actset->name'}}[$_-1];
                $buffer=pack('Z26',$this_chat);
                print CHAT $buffer;
        }

        $buffer = pack('v',
                ($chat{'total_chatacts'}));
        print CHAT $buffer;
        foreach (1..$chat{'total_chatacts'})  {
                my $this_chat = ${$chat{'chatact'}}[$_-1];
                my %this_chat = %{$this_chat};
                $buffer=pack('vZ10Z66Z16',
                        ($this_chat{'actset'},$this_chat{'cmd'},
                        $this_chat{'out'},$unused));
                print CHAT $buffer;
        }

        $buffer = pack('v',
                ($chat{'total_chans'}));
        print CHAT $buffer;
        foreach (1..$chat{'total_chans'})  {
                my $this_chat = ${$chat{'chan'}}[$_-1];
                my %this_chat = %{$this_chat};
                $buffer=pack('vZ26Z9Z41VvVZ16',
                        ($this_chat{'actset'},$this_chat{'name'},
                        $this_chat{'code'},$this_chat{'ar'},
                        $this_chat{'cost'},$this_chat{'guru'},
                        $this_chat{'misc'},$unused));
                print CHAT $buffer;
        }

        $buffer = pack('v',
                ($chat{'total_pages'}));
        print CHAT $buffer;
        foreach (1..$chat{'total_pages'})  {
                my $this_chat = ${$chat{'page'}}[$_-1];
                my %this_chat = %{$this_chat};
                $buffer=pack('Z64Z41VZ16',
                        ($this_chat{'cmd'},$this_chat{'ar'},
                        $this_chat{'misc'},$unused));
                print CHAT $buffer;
        }

        close CHAT;
}


__END__
:endofperl
